/* ̧قDoxygenpɏĂ܂B				 */
/*! \file *********************************************************************
 *
 * \brief
 *		main.cAsUZgp̎
 *
 *		ᑬRCvZARCZƒdRC̎BᑬRC͍RCZ
 *		ULP RCɎg܂B
 *
 * \par pLq:
 *		AVR351: U̪̎gRCȖsZƕ⏞
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		xEҰ: avr@atmel.com
 *
 * $Revision: 4809 $
 * $Date: 2008-11-04 12:17:59 +0100 (ti, 04 nov 2008) $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 *****************************************************************************/

// ݸٰ ̧
#include "RC_calib_oscsampleif.h"
#include "ATmega8HVA_16HVA_signature.h"
#include "main.h"

// ّ̧Sϐ
uint16_t temp_sensor_coeff;		//!< VPTAT(xm)̉xvZp

void main (void)
{
	uint16_t current_temperature, calibration_temperature;
	int16_t  temp_diff;
	uint16_t slow_RC_period;

	//!< i[邾Ȃ̂źׂ߲̌x邽߂volatile錾
	volatile uint16_t ULP_RC_period;

	int8_t   button_pressed;

	/* ޷ެߎQƊZB͎[񂪑2}ް܂ނ𒲂ׂ
	 * Bsɑ΂钲͎܂B
	 */
	if (InitBandgap() == ROOM_TEMPERATURE){	
		// ōZꂽRC
		calibration_temperature = ZERO_C_IN_KELVIN + ROOM_TEMPERATURE;
	}else{
		// ōZꂽRC
		calibration_temperature = ZERO_C_IN_KELVIN + HOT_TEMPERATURE;
	}

	// [񂩂牷xmWǂőSϐɊi[
	temp_sensor_coeff =  READ_SIGNATUREBYTE(SIG_VPTAT_L);

	// Ȍ݂6łSPMCSRڼ޽݂B
	__delay_cycles(2);

	temp_sensor_coeff |= (READ_SIGNATUREBYTE(SIG_VPTAT_H) << 8);

	// eՂޯނ߂PB0ɼ ۯ/2o
	DDRB |= (1 << DDB0);
	MCUCR |= (1 << CKOE);

	// iJԂ˓
	do {
		/* ۂ̉pł͉x肪炭荞݋쓮VADC̈ʒułA
		 * ł͒Pɂ蓮ō̎悵܂B
		 */
		current_temperature = MeasureTemperature();
		temp_diff = current_temperature - calibration_temperature;
		button_pressed = ReadButtons();

		// x܂͖t3(PB3)̂ǂ炩ɂČĂ΂ꂽꍇɍZJn
		if ( (temp_diff > TEMP_DIFF_LIMIT) || (temp_diff < -TEMP_DIFF_LIMIT) || (button_pressed == BUTTON_THREE) ) {

			slow_RC_period = CalculateSlowRCperiod(current_temperature);
			ULP_RC_period = MeasureULPRCperiod(slow_RC_period);

			/* łULP RCƍRCZɑ΂ĒᑬRČʂg
			 * Bdrpł͒ᑬRC܂ULP RC ADCʂ⏞
			 * ̂ɂg܂BڍׂɂĂAVR352pLqB
			 */

			if (CalibrateFastRCruntime(slow_RC_period) == SUCCESS){
				// Zxۑ
				calibration_temperature = current_temperature;
			}else{
				// ňُ}ׂłB̉pł͉̊܂B
			}
		}

		// t1(PB1)ꂽꍇAFOSCCALɒ߁A]ĸۯgB
		if (button_pressed == BUTTON_ONE){
			FOSCCAL--;
		}
		
		// t2(PB2)ꂽꍇAFOSCCALɒ߁A]ĸۯg𑝉B
		if (button_pressed == BUTTON_TWO){
			FOSCCAL++;
		}
		
	} while(1);
}

/*! \brief tꂽ/ǂ݂܂B
 *
 *	͂ƂPB1/2/3gÂɂ͓(޲ ؾĎ̊)Ƃč\
 *	肳Ȃ΂Ȃ܂BʂԂOɖt̂҂܂B
 *
 *	\return ǂ̖tꂽA܂͂Ȃt̏ꍇFAILED
 */
int8_t ReadButtons (void)
{
	uint8_t buttons_pressed;
	int8_t return_value;
	buttons_pressed = (~PINB & BUTTON_MASK);

	do {} while (~PINB & BUTTON_MASK);

	switch( buttons_pressed ) {
		case (1 << BUTTON_ONE):
			return_value = BUTTON_ONE;
			break;
		case (1 << BUTTON_TWO):
			return_value = BUTTON_TWO;
			break;
		case (1 << BUTTON_THREE):
			return_value = BUTTON_THREE;
			break;
		default : 
			return_value = FAILED;
			break;
	}

	return return_value;
}

/*! \brief ޷ެߏ
 *
 *	޷ެߎQƊdHZɏBő2ZsꂽꍇA
 *	̒lݒ肳܂BBOD邽߂BGCCR͂ύX邱ƂKv
 *	łBڍׂɂĂ͉pLqB
 *
 *	\retval #FAILED				[ް̓ǂݍݎs
 *	\retval #ROOM_TEMPERATURE	2}p[ް
 *	\retval #HOT_TEMPERATURE	1}p[ް
 */
int8_t InitBandgap (void)
{
	//!< BGCCRBGCRR̍HZ
	uint8_t bgccr_cal, bgcrr_cal;
	int8_t  mode;

	bgcrr_cal = READ_SIGNATUREBYTE(SIG_BGCRR_CALIB_25C);

	/* 2_Zsɂ͈ȉ̍s̒߂OĂB[޲ēǂݍ݊
	 * 2̒fAVR Studioׯǂݏosɂ邱ƂɒӂĂ
	 * B
	 */
//	bgcrr_cal = 0xFF;

	// [ɗLBGCRRl݂邩
	if ( bgcrr_cal != 0xFF ){
		bgccr_cal = 0x3F & READ_SIGNATUREBYTE(SIG_BGCCR_CALIB_25C);	
		mode = ROOM_TEMPERATURE;
	}else{
		// Ll݂ȂBްǂݍݐݒAꂪ̏ꍇɒ~
		bgcrr_cal = 0x0F;
		bgccr_cal = 0x3F & READ_SIGNATUREBYTE(SIG_BGCCR_CALIB_HOT);

		if (bgccr_cal == 0x3F) {
			return FAILED;
		}

		mode = HOT_TEMPERATURE;
	}

	BGCRR = bgcrr_cal;

	// ̕@sꍇA޲BODɓ邩ꂸÂɈȍ~̕@gĂB
	// BGCCR = bgccr_cal;

	// KvȂBGCCR㏸BBOD邽߂ɂ
	while (BGCCR < bgccr_cal) {
		BGCCR++;
		__delay_cycles(BANDGAP_ADJ_DELAY);
	}

	/* KvȂΉ~B(BODɊւĈSłÂ߂ɂ蒷Ԃg
	 * A]ĐADC^ĂB)
	 */
	BGCCR = bgccr_cal;

	return mode;
}

/*! \brief x
 *
 *	(uint16_t)ŉxԂ܂Bxm̐ΐxްĂŁ}5݂
 *	qׂĂ܂B
 *
 *	ւ1޲Ă̕t`ŁgƂłA]+128`-128͈̔͂
 *	^܂Bpł͉x肪荞݂Ő䂳ꂽADC̈ꕔłׂ
 *	B
 *
 *	\return temperature [] (uint16_t)
 */
uint16_t MeasureTemperature (void)
{
	uint32_t temperature;

	// ͂ƂVTEMP
	VADMUX = VTEMP;

	temperature = VADC;

	// VADCƕϊJn
	VADCSR = (1 << VADEN) | (1 << VADSC) | (1 << VADCCIF);

	do {} while(!(VADCSR & (1 << VADCCIF)));

	temperature = VADC;
	temperature *= temp_sensor_coeff;

	// VADC֎~Ɗ荞׸ ؾāAiŝǂ̕ϊf܂B
	VADCSR = (1 << VADCCIF);
	return ((uint16_t)(temperature >> 14));
}
